<html lang="en">
<head>
<title>Entity manager - psgml</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="psgml">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="prev" href="Invoke.html#Invoke" title="Invoke">
<link rel="next" href="Validate.html#Validate" title="Validate">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Entity-manager"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Validate.html#Validate">Validate</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Invoke.html#Invoke">Invoke</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="index.html#Top">Top</a>
<hr>
</div>

<!-- node-name,  next,  previous,  up -->
<h2 class="chapter">4 The Entity Manager</h2>

<p><a name="index-public-identifier-10"></a><a name="index-system-identifier-11"></a><a name="index-external-identifier-12"></a><a name="index-entity-catalog-13"></a>
<!-- *** sgml-sysid-resolve-functions -->

   <p>SGML can refer to an external file (really entity) with an
<em>external identifier</em>, this is a <em>public identifier</em> or a
<em>system identifier</em>, or both.

   <p>A typical public identifier looks like

<pre class="example">     PUBLIC "ISO 8879:1986//ENTITIES Added Latin 1//EN"
</pre>
   <p class="noindent">where &ldquo;ISO 8879:1986&rdquo; is the owner, &ldquo;ENTITIES&rdquo; is the text class and
&ldquo;Added Latin 1&rdquo; is the text description (and &ldquo;EN&rdquo; is language).

   <p>A system identifier looks like

<pre class="example">     SYSTEM "htmlplus.dtd"
</pre>
   <p class="noindent">where &ldquo;htmlplus.dtd&rdquo; is a system-specific identifier.

   <p>To map external identifiers to file names, PSGML first searches entity
catalog files and then search the list of file name templates in the
variable <code>sgml-public-map</code>.

   <p>The catalog format is according to SGML/Opens resolution on entity
management.  The catalog consists of a series of entries and comments.  A
comment is delimited by `<samp><span class="samp">--</span></samp>' like in a markup declaration. 
The entry types recognized are described in the following table.

     <dl>
<dt>`<samp><span class="samp">public </span><var>pubid</var> <var>file</var></samp>'<dd>The <var>file</var> will be used for the entity text of an entity
with the public identifier <var>pubid</var>.

     <br><dt>`<samp><span class="samp">entity </span><var>name</var> <var>file</var></samp>'<dd>The <var>file</var> will be used for the entity text of an entity
with the name <var>name</var>.  If the <var>name</var> starts with a `<samp><span class="samp">%</span></samp>' the
rest of the name will be matched against parameter entities.

     <br><dt>`<samp><span class="samp">doctype </span><var>name</var> <var>file</var></samp>'<dd>The <var>file</var> will be used for the entity text of an entity
used as external subset of a document declaration with <var>name</var> as
document type name.

     <br><dt>`<samp><span class="samp">sgmldecl </span><var>file</var></samp>'<dd>Used to specify a default SGML declaration.  Recognized but not used by
PSGML other than to pass to an external validation command
(<code>sgml-validate-command</code>).

   </dl>

   <p>When PSGML is looking for the file containing an external entity, the
following things will be tried in order:

     <ol type=1 start=1>

     <p><a name="index-sgml_002dsystem_002didentifiers_002dare_002dpreferred-14"></a><li>Try the system identifier, as a file name, if there is a system
identifier and the variable <code>sgml-system-identifiers-are-preferred</code>
is non-<code>nil</code> and there is no elements containing `<samp><span class="samp">%s</span></samp>' in
<code>sgml-public-map</code>.  If the system identifier is a relative file name
it will be relative to the directory containing the defining entity.

     <li>Look thru each catalog in <code>sgml-local-catalogs</code> and
<code>sgml-catalog-files</code> in order.  For each catalog look first for
entries matching the public identifier, if any.  Then look for other
matching entries in the order they appear in the catalog.

     <p>Currently an entry will be ignored if it is matching but its file is
non-existent or unreadable.  (This is under reconsideration, perhaps it
should signal error instead).

     <li>Try the system identifier, if any, as a file name. 
If <code>sgml-system-identifiers-are-preferred</code> is <code>nil</code>
and there is no elements containing `<samp><span class="samp">%s</span></samp>' in <code>sgml-public-map</code>.

     <li>Try the entries in <code>sgml-public-map</code>.  Using the catalogs are
preferred.  The <code>sgml-public-map</code> may disappear in a future version
of PSGML (not soon though).

        </ol>

   <p>The <code>sgml-public-map</code> variable can contain a list of file name
templates where `<samp><span class="samp">%P</span></samp>' will be substituted with the whole public
identifier, owner is substituted for `<samp><span class="samp">%O</span></samp>', public text class for
`<samp><span class="samp">%C</span></samp>', and public text description for `<samp><span class="samp">%D</span></samp>'.  The text class
will be converted to lower case and the owner and description will be
transliterated according to the variable
<code>sgml-public-transliterations</code>.  The templates in the list is tried
in order until an existing file is found.  The <code>sgml-public-map</code> is
modeled after <samp><span class="file">sgmls</span></samp> environment variable <code>SGML_PATH</code> and
psgml understand the following substitution characters: %%, %N, %P, %S,
%Y, %C, %L, %O, %T, and %V.  The default value of
<code>sgml-public-map</code> is taken from the environment variable
<code>SGML_PATH</code>.

   <p>Given the public identifier above and the file name template
`<samp><span class="samp">/usr/local/lib/sgml/%o/%c/%d</span></samp>', the resulting file name is

<pre class="example">     /usr/local/lib/sgml/ISO_8879:1986/entities/Added_Latin_1
</pre>
   <p>Note: blanks are transliterated to `<samp><span class="samp">_</span></samp>' (and also `<samp><span class="samp">/</span></samp>' to
`<samp><span class="samp">%</span></samp>') and the text class is down cased.

<div class="defun">
&mdash; User Option: <b>sgml-catalog-files</b><var><a name="index-sgml_002dcatalog_002dfiles-15"></a></var><br>
<blockquote><p>This is a list of catalog entry files. 
The files are in the format defined in the SGML Open Draft Technical
Resolution on Entity Management.  The Emacs variable is initialized from
the environment variable <code>SGML_CATALOG_FILES</code> or if this variable
is undefined the default is

     <pre class="lisp">          ("CATALOG" "/usr/local/lib/sgml/CATALOG")
     </pre>
        </blockquote></div>

<div class="defun">
&mdash; User Option: <b>sgml-local-catalogs</b><var><a name="index-sgml_002dlocal_002dcatalogs-16"></a></var><br>
<blockquote><p>A list of SGML entity catalogs to be searched first when parsing the
buffer.  This is used in addition to <code>sgml-catalog-files</code>, and
<code>sgml-public-map</code>.  This variable is automatically local to the
buffer. 
</p></blockquote></div>

<div class="defun">
&mdash; User Option: <b>sgml-system-identifiers-are-preferred</b><var><a name="index-sgml_002dsystem_002didentifiers_002dare_002dpreferred-17"></a></var><br>
<blockquote><p>If <code>nil</code>, PSGML will look up external entities by searching the
catalogs in <code>sgml-local-catalogs</code> and <code>sgml-catalog-files</code> and
only if the entity is not found in the catalogs will a given system
identifier be used.  If the variable is non-nil and a system identifier is
given, the system identifier will be used for the entity.  If no system
identifier is given the catalogs will searched. 
</p></blockquote></div>

<div class="defun">
&mdash; User Option: <b>sgml-public-map</b><var><a name="index-sgml_002dpublic_002dmap-18"></a></var><br>
<blockquote><p>This should be a list of file name templates.  This variable is
initialized from the environment variable <code>SGML_PATH</code>.  This is
the same environment variable that <samp><span class="file">sgmls</span></samp> uses.  If the
environment variable is undefined the default is

     <pre class="lisp">          ("%S" "/usr/local/lib/sgml/%o/%c/%d")
     </pre>
        <!-- Mapping from public identifiers to file names. -->
</blockquote></div>

<!-- the colon separated list in @code{SGML_PATH} is converted to a lisp list -->
<!--  -->
</body></html>

